<< problem 160 - Factorial trailing digits | Hexadecimal numbers - problem 162 >> |
Problem 161: Triominoes
(see projecteuler.net/problem=161)
A triomino is a shape consisting of three squares joined via the edges. There are two basic forms:
If all possible orientations are taken into account there are six:
Any n by m grid for which nxm is divisible by 3 can be tiled with triominoes.
If we consider tilings that can be obtained by reflection or rotation from another tiling as different
there are 41 ways a 2 by 9 grid can be tiled with triominoes:
In how many ways can a 9 by 12 grid be tiled in this way by triominoes?
My Algorithm
I wrote a typical Dynamic Programming solution:
- the grid is filled from top to bottom
- bit masks represent whether a cell of the grid is occupied (=1) or available/empty (=0)
search
attempts to place every shape in the top-most and left-most empty cell
1. All rows are either empty, partially filled or full
2. There are at most 3 partially filled rows (due to my strict "from-top-to-bottom" algorithm)
My memoization hash therefore consists only of the number of empty rows and the bitmasks of (up to) three partially filled rows.
For the 9x12 grid, it just fits into a 32 bit integer.
The number of solutions for a grid of size n x m is identical to a grid of size m x n.
The hash is "smaller" and creates more opportunities for memoization hits when the rows are small.
Modifications by HackerRank
The result has to be printed modulo 1000000007
.
Note
I was surprised to find only 223255 values in cache
(for the 9x12 grid).
On the other side, the rotated 12x9 grid would cause over 5 million values (and run about 70x slower).
However, my std::swap
optimization automatically converts the 12x9 grid to a 9x12 grid.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho "2 9" | ./161
Output:
Note: the original problem's input 9 12
cannot be entered
because just copying results is a soft skill reserved for idiots.
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
The code contains #ifdef
s to switch between the original problem and the Hackerrank version.
Enable #ifdef ORIGINAL
to produce the result for the original problem (default setting for most problems).
#include <iostream>
#include <unordered_map>
#define ORIGINAL
// grid size
unsigned int height = 9;
unsigned int width = 2;
// indicate an empty row
const unsigned int EmptyRow = 0;
// set a certain bit to one (= position is not available anymore), return true if bit was zero
// note: second parameter is an in/out parameter
bool use(unsigned int pos, unsigned int& row)
{
unsigned int mask = 1 << pos;
bool result = (row & mask) == 0;
row |= mask;
return result;
}
// recursive search
unsigned long long search(unsigned int rowsLeft,
unsigned int rowA, unsigned int rowB, unsigned int rowC)
{
// done ?
if (rowsLeft == 0)
return 1;
// filled another row ?
unsigned int fullRow = (1 << width) - 1;
if (rowA == fullRow)
return search(rowsLeft - 1, rowB, rowC, EmptyRow);
// find first gap in rowA
unsigned int pos = 0;
while ((rowA & (1 << pos)) != 0)
pos++;
// unique ID
unsigned long long hash; // unsigned int would suffice for grid with up to 9 columns, too
hash = rowsLeft;
hash <<= width;
hash |= rowA;
hash <<= width;
hash |= rowB;
hash <<= width;
hash |= rowC;
// about twice as fast as std::map
static std::unordered_map<unsigned long long, unsigned long long> cache;
auto i = cache.find(hash);
if (i != cache.end())
return i->second;
unsigned long long result = 0;
// shape: ##
// #
unsigned int a = rowA;
unsigned int b = rowB;
unsigned int c = rowC;
if (rowsLeft >= 2 && pos < width - 1 &&
use(pos, a) && use(pos + 1, a) && use(pos, b))
result += search(rowsLeft, a, b, c);
// shape: ##
// #
a = rowA; b = rowB; //c = rowC;
if (rowsLeft >= 2 && pos < width - 1 &&
use(pos, a) && use(pos + 1, a) && use(pos + 1, b))
result += search(rowsLeft, a, b, c);
// shape: #
// ##
a = rowA; b = rowB; //c = rowC;
if (rowsLeft >= 2 && pos < width - 1 &&
use(pos, a) && use(pos, b) && use(pos + 1, b))
result += search(rowsLeft, a, b, c);
// shape: #
// ##
// note: this shape extends one "negative" unit to the left
a = rowA; b = rowB; //c = rowC;
if (rowsLeft >= 2 && pos > 0 && pos < width &&
use(pos, a) && use(pos - 1, b) && use(pos, b))
result += search(rowsLeft, a, b, c);
// shape: #
// #
// #
a = rowA; b = rowB; //c = rowC;
if (rowsLeft >= 3 && pos < width &&
use(pos, a) && use(pos, b) && use(pos, c))
result += search(rowsLeft, a, b, c);
// shape: ###
a = rowA; b = rowB; c = rowC;
if (rowsLeft >= 1 && pos < width - 2 &&
use(pos, a) && use(pos + 1, a) && use(pos + 2, a))
result += search(rowsLeft, a, b, c);
#ifndef ORIGINAL
result %= 1000000007; // Hackerrank only
#endif
// memoize
cache[hash] = result;
return result;
}
int main()
{
// read grid size
std::cin >> width >> height;
// prefer fewer columns
if (width > height)
std::swap(width, height);
// let's go !
std::cout << search(height, EmptyRow, EmptyRow, EmptyRow) << std::endl;
return 0;
}
This solution contains 21 empty lines, 27 comments and 5 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in 0.07 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
Peak memory usage was about 11 MByte.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
June 29, 2017 submitted solution
June 29, 2017 added comments
Hackerrank
see https://www.hackerrank.com/contests/projecteuler/challenges/euler161
My code solves 11 out of 11 test cases (score: 100%)
Difficulty
Project Euler ranks this problem at 70% (out of 100%).
Hackerrank describes this problem as hard.
Note:
Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.
In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is rarely an option.
Links
projecteuler.net/thread=161 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
Python github.com/frrad/project-euler/blob/master/python/Problem161.py (written by Frederick Robinson)
Python github.com/Meng-Gen/ProjectEuler/blob/master/161.py (written by Meng-Gen Tsai)
C++ github.com/roosephu/project-euler/blob/master/161.cpp (written by Yuping Luo)
Java github.com/HaochenLiu/My-Project-Euler/blob/master/161.java (written by Haochen Liu)
Java github.com/thrap/project-euler/blob/master/src/Java/Problem161.java (written by Magnus Solheim Thrap)
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 | 697 | 698 | 699 | 700 |
701 | 702 | 703 | 704 | 705 | 706 | 707 | 708 | 709 | 710 | 711 | 712 | 713 | 714 | 715 | 716 | 717 | 718 | 719 | 720 | 721 | 722 | 723 | 724 | 725 |
726 | 727 | 728 | 729 | 730 | 731 | 732 | 733 | 734 | 735 | 736 | 737 | 738 | 739 | 740 | 741 | 742 | 743 | 744 | 745 | 746 | 747 | 748 | 749 | 750 |
751 | 752 | 753 | 754 | 755 | 756 | 757 | 758 | 759 | 760 | 761 | 762 | 763 | 764 | 765 | 766 | 767 | 768 | 769 | 770 | 771 | 772 | 773 | 774 | 775 |
776 | 777 | 778 | 779 | 780 | 781 | 782 | 783 | 784 | 785 | 786 | 787 | 788 | 789 | 790 | 791 | 792 | 793 | 794 | 795 | 796 | 797 | 798 | 799 | 800 |
801 | 802 | 803 | 804 | 805 | 806 | 807 | 808 | 809 | 810 | 811 | 812 | 813 | 814 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 160 - Factorial trailing digits | Hexadecimal numbers - problem 162 >> |